<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-plus"
          size="mini"
          :disabled="multiple"
          @click="handleCombination"
          v-hasPermi="['pro:combination:add']"
        >追加到组合单
        </el-button>
      </el-col>
    </el-row>


    <el-table
      v-loading="loading"
      :data="workorderList"
      row-key="workorderId"
      default-expand-all
      @selection-change="handleSelectionChange"
      :tree-props="{ children: 'children', hasChildren: 'hasChildren' }"
    >
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="工单编码" width="180" prop="workorderCode"/>
      <el-table-column
        label="组合单号"
        width="180"
        align="center"
        prop="combinationCode"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="工单名称"
        width="200"
        align="center"
        prop="workorderName"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="工单来源" align="center" prop="orderSource">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.mes_workorder_sourcetype"
            :value="scope.row.orderSource"
          />
        </template>
      </el-table-column>
      <el-table-column
        label="工艺名称"
        width="160"
        align="center"
        prop="routeName"
        show-overflow-tooltip
      />
      <el-table-column
        label="订单编号"
        width="140"
        align="center"
        prop="sourceCode"
      />
      <el-table-column
        label="产品编号"
        width="120"
        align="center"
        prop="productCode"
      />
      <el-table-column
        label="产品名称"
        width="200"
        align="center"
        prop="productName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="规格型号"
        align="center"
        prop="productSpc"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="单位" align="center" prop="unitOfMeasure"/>
      <el-table-column label="工单数量" align="center" prop="quantity"/>
      <el-table-column label="调整数量" align="center" prop="quantityChanged"/>
      <el-table-column
        label="已生产数量"
        align="center"
        width="100px"
        prop="quantityProduced"
      />
      <el-table-column
        label="批次号"
        align="center"
        width="100px"
        prop="batchCode"
      />
      <el-table-column
        label="编排单号"
        align="center"
        width="100px"
        prop="arrangeCode"
      />
      <el-table-column label="客户编码" align="center" prop="clientCode"/>
      <el-table-column
        label="客户名称"
        align="center"
        prop="clientName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="需求日期"
        align="center"
        prop="requestDate"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.requestDate, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <el-table-column label="单据状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.mes_workorder_status"
            :value="scope.row.status"
          />
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import {
  listWorkorder,
  getWorkorder,
  delWorkorder,
  addWorkorder,
  updateWorkorder,
  dofinish,
  doCheckToolNum
} from "@/api/mes/pro/workorder";
import {addProtaskList} from "@/api/mes/pro/protask";
import ItemSelect from "@/components/itemSelect/single.vue";
import ClientSelect from "@/components/clientSelect/single.vue";
import VendorSelect from "@/components/vendorSelect/single.vue";
import {genCode} from "@/api/system/autocode/rule";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {getToken} from "@/utils/auth";
import {batchAddCombination} from "@/api/mes/pro/combination";

export default {
  name: "chooseWorkorderForComb",
  dicts: [
    "mes_workorder_status",
    "mes_workorder_sourcetype",
    "mes_workorder_type",
  ],
  props: {
    combinationCode: {
      type: String,
      default: null
    }
  },
  components: {
    ItemSelect,
    ClientSelect,
    VendorSelect,
  },
  data() {
    return {
      //自动生成编码
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 非单个禁用
      single: true,
      // 总条数
      total: 0,
      // 非多个禁用
      multiple: true,
      // 生产工单表格数据
      workorderList: [],
      // 生产工单树选项
      workorderOptions: [],
      selectedRows: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/mes/pro/workorder/importData",
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        workorderCode: null,
        workorderName: null,
        orderSource: null,
        sourceCode: null,
        productId: null,
        productCode: null,
        productName: null,
        productSpc: null,
        routeName: null,
        unitOfMeasure: null,
        quantity: null,
        quantityProduced: null,
        quantityChanged: null,
        quantityScheduled: null,
        clientId: null,
        clientCode: null,
        clientName: null,
        requestDate: null,
        parentId: null,
        ancestors: null,
        statusArr: ["PREPARE", "PUBLISHED"],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        workorderCode: [
          {required: true, message: "工单编码不能为空", trigger: "blur"},
        ],
        workorderName: [
          {required: true, message: "工单名称不能为空", trigger: "blur"},
        ],
        workorderType: [
          {required: true, message: "请选择生产工单类型", trigger: "blur"},
        ],
        orderSource: [
          {required: true, message: "来源类型不能为空", trigger: "blur"},
        ],
        productId: [
          {required: true, message: "产品不能为空", trigger: "blur"},
        ],
        productCode: [
          {required: true, message: "产品编号不能为空", trigger: "blur"},
        ],
        productName: [
          {required: true, message: "产品名称不能为空", trigger: "blur"},
        ],
        quantity: [
          {required: true, message: "生产数量不能为空", trigger: "blur"},
        ],
        requestDate: [
          {required: true, message: "需求日期不能为空", trigger: "blur"},
        ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async handleCombination() {
      let params = []
      let shouldExit = false;
      this.selectedRows.forEach((item, index) => {
        if (item.combinationCode != '' && item.combinationCode != null) {
          this.$modal.msgWarning(`${item.workorderCode}生产单已绑定组合单，不能再绑定！`);
          shouldExit = true
        }
        params.push({
          combinationSort: index,
          workorderId: item.workorderId,
          workorderCode: item.workorderCode,
          salesOrderId: 0,
          combinationCode: this.combinationCode
        })
      });
      if (!shouldExit) {
        batchAddCombination(params).then(response => {
          this.$modal.msgSuccess("追加组合单成功");
          this.getList();
        });
      }

    },
    /** 查询生产工单列表 */
    getList() {
      this.loading = true;
      listWorkorder(this.queryParams).then((response) => {
        this.workorderList = this.handleTree(
          response.rows,
          "workorderId",
          "parentId"
        );
        this.total = response.total;
        this.loading = false;
      });
    },
    importTemplate() {
      this.download(
        "mes/pro/workorder/importTemplate",
        {},
        `work_order_template_${new Date().getTime()}.xlsx`
      );
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.open = true;
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(
        "<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" +
        response.msg +
        "</div>",
        "导入结果",
        {dangerouslyUseHTMLString: true}
      );
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 转换生产工单数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.workorderId,
        label: node.workorderName,
        children: node.children,
      };
    },
    /** 查询生产工单下拉树结构 */
    getTreeselect() {
      listWorkorder().then((response) => {
        this.workorderOptions = [];
        const data = {
          workorderId: 0,
          workorderName: "顶级节点",
          children: [],
        };
        data.children = this.handleTree(
          response.data,
          "workorderId",
          "parentId"
        );
        this.workorderOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        workorderId: null,
        workorderCode: null,
        workorderName: null,
        workorderType: "SELF",
        orderSource: null,
        sourceCode: null,
        productId: null,
        productCode: null,
        productName: null,
        productSpc: null,
        routeName: null,
        unitOfMeasure: null,
        quantity: null,
        quantityProduced: null,
        quantityChanged: null,
        quantityScheduled: null,
        clientId: null,
        clientCode: null,
        clientName: null,
        vendorId: null,
        vendorCode: null,
        vendorName: null,
        requestDate: null,
        parentId: null,
        status: "PREPARE",
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      };
      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },

    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    //从BOM行中直接新增
    handleSubAdd(row) {
      this.open = false;
      this.reset();
      this.getTreeselect();
      if (row != null && row.workorderId) {
        this.form = row;
        this.form.parentId = row.workorderId;
        this.form.workorderId = null;
        this.form.workorderCode = null;
      } else {
        this.form.parentId = 0;
      }
      this.open = true;
      this.title = "添加生产工单";
      this.optType = "add";
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.getTreeselect();
      // 跳转到申请单界
      this.$router.push("/mes/pro/workorder/apply");
      return;
      //  this.reset();
      // this.getTreeselect();
      // if (row != null && row.workorderId) {
      //   this.form.parentId = row.workorderId;
      //   this.form.orderSource = row.orderSource;
      //   this.form.sourceCode = row.sourceCode;
      //   this.form.clientId = row.clientId;
      //   this.form.clientCode = row.clientCode;
      //   this.form.clientName = row.clientName;
      // } else {
      //   this.form.parentId = 0;
      // }
      // this.open = true;
      // this.title = "添加生产工单";
      // this.optType="add";
    },
    // 查询明细按钮操作
    handleView(row) {
      handleView
      this.reset();
      this.getTreeselect();
      const workorderId = row.workorderId || this.ids;
      this.$router.push("/mes/pro/workorder/info?workorderId=" + workorderId);

      // this.reset();
      // this.getTreeselect();
      // const workorderId = row.workorderId || this.ids;
      // getWorkorder(workorderId).then(response => {
      //   this.form = response.data;
      //   this.open = true;
      //   this.title = "查看工单信息";
      //   this.optType = "view";
      // });
    },
    handleSelectionChange(selection) {
      // this.selectedRows = val;
      this.selectedRows = selection;
      this.ids = selection.map(item => item.toolId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    //   // 多选框选中数据
    // handleSelectionChange(selection) {
    //   this.ids = selection.map(item => item.toolId)
    //   this.single = selection.length!==1
    //   this.multiple = !selection.length
    // },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();

      const workorderId = row.workorderId || this.ids;
      this.$router.push("/mes/pro/workorder/edit?workorderId=" + workorderId);

      // this.reset();
      // this.getTreeselect();
      // if (row != null) {
      //   this.form.parentId = row.workorderId;
      // }
      // getWorkorder(row.workorderId).then(response => {
      //   this.form = response.data;
      //   this.open = true;
      //   this.title = "修改生产工单";
      //   this.optType="edit";
      // });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.workorderId != null) {
            updateWorkorder(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              //this.open = false;
              this.$refs["bomlist"].getList();
              this.getList();
            });
          } else {
            addWorkorder(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              //this.open = false;
              this.form.workorderId = response.data;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal
        .confirm(
          '是否确认删除生产工单编号为"' + row.workorderId + '"的数据项？'
        )
        .then(function () {
          return delWorkorder(row.workorderId);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {
        });
    },
    /** 生产任务单操作 */
    handleDofinish() {
      this.$modal
        .confirm("是否生成选中的任务单？")
        .then(() => {
          const ids = this.selectedRows.map((v) => v.workorderId);
          console.log("00000", ids);

          return addProtaskList(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("生成成功");
        })
        .catch(() => {
        });
    },
    handleToolNumCheck() {
      this.$modal
        .confirm("是否检查刀具模版齐套？")
        .then(() => {
          const ids = this.selectedRows.map((v) => v.workorderId);
          return doCheckToolNum(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("已齐套");
        })
        .catch(() => {
        });
    },
    handleSelectProduct() {
      this.$refs.itemSelect.showFlag = true;
    },
    handleSelectClient() {
      this.$refs.clientSelect.showFlag = true;
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "mes/pro/workorder/export",
        {
          ...this.queryParams,
        },
        `workorder_${new Date().getTime()}.xlsx`
      );
    },
    handleConfirm() {
      let that = this;
      this.$modal
        .confirm("是确认完成工单编制？【确认后将不能更改】")
        .then(function () {
          that.form.status = "CONFIRMED";
          that.submitForm();
        });
    },
    handleFinish(row) {
      const workorderIds = row.workorderId || this.ids;
      this.$modal
        .confirm("确认完成工单？一旦完成，此工单将无法继续报工")
        .then(function () {
          return dofinish(workorderIds); //完成工单
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("更改成功");
        })
        .catch(() => {
        });
    },
    // //物料选择弹出框
    // onItemSelected(obj){
    //     if(obj != undefined && obj != null){
    //       this.form.productId = obj.itemId;
    //       this.form.productCode = obj.itemCode;
    //       this.form.productName = obj.itemName;
    //       this.form.productSpc = obj.specification;
    //       this.form.unitOfMeasure = obj.unitOfMeasure;
    //     }
    // },
    //客户选择弹出框
    onClientSelected(obj) {
      if (obj != undefined && obj != null) {
        this.form.clientId = obj.clientId;
        this.form.clientCode = obj.clientCode;
        this.form.clientName = obj.clientName;
      }
    },
    //供应商选择
    handleSelectVendor() {
      this.$refs.vendorSelect.showFlag = true;
    },
    //供应商选择弹出框
    onVendorSelected(obj) {
      debugger;
      if (obj != undefined && obj != null) {
        this.form.vendorId = obj.vendorId;
        this.form.vendorCode = obj.vendorCode;
        this.form.vendorName = obj.vendorName;
      }
    },
    /** 完成任务单操作 */
    confirmWorkorder(row) {
      this.$modal
        .confirm(
          '是否将工单编号"' + row.workorderCode + '"的草稿数据项改为已确认？'
        )
        .then(function () {
          return confirmedWorkorder(row.workorderId);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("已确认成功");
        })
        .catch(() => {
        });
    },
    //自动生成编码
    handleAutoGenChange(autoGenFlag) {
      if (autoGenFlag) {
        genCode("WORKORDER_CODE").then((response) => {
          this.form.workorderCode = response;
        });
      } else {
        this.form.workorderCode = null;
      }
    },
  },
};
</script>
